<template>
    <v-container>
        <v-list three-line>
            <template v-for="(w, i) in workers">
                <v-list-item :key="w.id">
                    <v-list-item-avatar>
                        <v-img v-if="w.image != ''" :src="w.image" alt="profile"/>
                        <span v-else class="white---text headline">{{w.name.CapitalizeWords().split(' ').Map(x=>x.Take())}}</span>
                    </v-list-item-avatar>
                    <v-list-item-content>
                        <v-list-item-title>{{w.name}}</v-list-item-title>
                        <v-list-item-subtitle> {{w.trade}} • {{w.tag}}</v-list-item-subtitle>
                        <v-list-item-subtitle> {{w.id}}</v-list-item-subtitle>
                    </v-list-item-content>
                </v-list-item>
            </template>
        </v-list>
    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Prop, Vue} from 'vue-property-decorator';
    import {coreApi} from "../init";
    import "moment-timezone";
    import {WorkerLightResponse} from "../../../classLibrary/core/workerLightResponse";
    import {WorkerResponse} from "../../../classLibrary/core/workerResponse";

    interface WorkerInfo {
        name: string;
        trade: string;
        image: string;
        id: string;
        tag: string;
    }

    @Component
    export default class FloorPlans extends Vue {

        workers: WorkerInfo[] = [];
        @Prop() sub!: string;

        // wname = "";
        // wtag = "";
        // wtrade = "";

        // async createWorker() {
        //     if (this.wname == "") {
        //         (this.$parent as any).error = "name cannot be empty";
        //     }
        //
        //     if (this.wtag == "") {
        //         (this.$parent as any).error = "tag cannot be empty";
        //     }
        //
        //     if (this.wtrade == "") {
        //         (this.$parent as any).error = "trade cannot be empty";
        //     }
        //
        //     const r = await coreApi.Post<WorkerLightResponse>(`Worker/${this.sub}`, {
        //         name: this.wname,
        //         trade: this.wtrade,
        //         image: "lolol",
        //         data: {},
        //     });
        //     if (!r.success) {
        //         (this.$parent as any).error = r.error!;
        //         return
        //     }
        //
        //     const wid = r.Ok!.light.id;
        //     const r1 = await coreApi.Post<TagResponse>(`Tag`, {
        //         mac: this.wtag,
        //         labels: [],
        //     });
        //     if (!r1.success) {
        //         (this.$parent as any).error = r1.error!;
        //         return
        //     }
        //
        //     const r2 = await coreApi.Post<TagResponse>(`Tag/${this.wtag}/add/${wid}`);
        //     if (!r2.success) {
        //         (this.$parent as any).error = r2.error!;
        //         return
        //     }
        //
        //     await this.load();
        //
        // }

        async load() {
            const r = await coreApi.Get<WorkerLightResponse[]>(`Worker/${this.sub}`);
            if (r.Ok) {

                this.workers = await Promise.all(r.Ok.Map(async (x) => {
                    const r1 = await coreApi.Get<WorkerResponse>(`Worker/${this.sub}/${x.id}`);
                    if (r1.Ok) {
                        return {
                            name: x.name,
                            tag: r1.Ok!.tag.macAddress,
                            trade: x.trade,
                            image: x.image,
                            id: x.id,
                        } as WorkerInfo
                    } else {
                        (this.$parent as any).error = r!.error!;
                        return {
                            name: x.name,
                            tag: "",
                            trade: x.trade,
                            image: x.image,
                            id: x.id,
                        } as WorkerInfo
                    }
                }));
            } else {
                (this.$parent as any).error = r.error!;
            }
        }

        async created() {
            await this.load();

        }
    }
</script>
